#ifndef C2CBASE_H
#define C2CBASE_H

#include "PlatoonProtocolLib/Vehicle.h"
#include "PlatoonProtocolLib/LeaderVehicle.h"
#include "PlatoonProtocolLib/FollowerVehicle.h"
#include "PlatoonProtocolLib/Protocol.h"
#include "PlatoonState.h"

namespace car
{
  
  
class C2CBase
{
    friend class PlatoonController; // only the PlatoonControler should be able to use the swap functions below!
    public:
        C2CBase();
      
    private:
        PlatoonState curState = PlatoonState::ACC;
      
        networking::Networking c2cNetLeader;   // thread  + event queue
        networking::Networking c2cNetFollower; // thread  + event queue
      
        platoonProtocol::LeaderVehicle::Ptr   c2cLeader;
        platoonProtocol::FollowerVehicle::Ptr c2cFollower;
      
        void swap2LV();
        void swap2FV();
        void swap2ACC();

        bool isPlatoonRunning();
        platoonProtocol::PlatoonConfig getPlatoonConfig();

};

}

#endif // C2CBASE_H
